package du1;

/**
 *
 * @author Ing. Jaroslav Kuchař <kuchajar at fel.cvut.cz>
 */
public abstract class Nemovitost implements Comparable {

    private int id;

    private String nazev, adresa;
    private double plocha, cena;
    private Vlastnictvi vlastnictvi;
    private boolean rezervovano, prodano;

    public Nemovitost(String nazev, String adresa, double plocha, double cena, Vlastnictvi vlastnictvi) {
        this.nazev = nazev;
        this.adresa = adresa;
        this.plocha = plocha;
        this.cena = cena;
        this.vlastnictvi = vlastnictvi;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public boolean isProdano() {
        return prodano;
    }

    public void setProdano(boolean prodano) {
        this.prodano = prodano;
    }

    public boolean isRezervovano() {
        return rezervovano;
    }

    public void setRezervovano(boolean rezervovano) {
        this.rezervovano = rezervovano;
    }

    public String getAdresa() {
        return adresa;
    }

    public void setAdresa(String adresa) {
        this.adresa = adresa;
    }

    public double getCena() {
        return cena;
    }

    public void setCena(double cena) {
        this.cena = cena;
    }

    public String getNazev() {
        return nazev;
    }

    public void setNazev(String nazev) {
        this.nazev = nazev;
    }

    public double getPlocha() {
        return plocha;
    }

    public void setPlocha(double plocha) {
        this.plocha = plocha;
    }

    public Vlastnictvi getVlastnictvi() {
        return vlastnictvi;
    }

    public void setVlastnictvi(Vlastnictvi vlastnictvi) {
        this.vlastnictvi = vlastnictvi;
    }

    @Override
    public String toString() {
        return nazev + ", " + adresa + ", " + plocha + ", " + cena + ", " + vlastnictvi;
    }

    public int compareTo(Object o) {
        Nemovitost n = (Nemovitost) o;
        if (cena == n.cena) {
            return 0;
        }
        return (cena > n.cena ? 1 : -1);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (!(obj instanceof Nemovitost)) {
            return false;
        }
        Nemovitost n = (Nemovitost) obj;
        return (n.getClass()==getClass() && n.adresa.equals(adresa) && n.cena == cena && n.nazev.equals(nazev) && n.plocha == plocha && n.vlastnictvi == vlastnictvi);

    }

    @Override
    public int hashCode() {
        int hash = 3;
        hash = 53 * hash + (this.nazev != null ? this.nazev.hashCode() : 0);
        hash = 53 * hash + (this.adresa != null ? this.adresa.hashCode() : 0);
        hash = 53 * hash + (int) (Double.doubleToLongBits(this.plocha) ^ (Double.doubleToLongBits(this.plocha) >>> 32));
        hash = 53 * hash + (int) (Double.doubleToLongBits(this.cena) ^ (Double.doubleToLongBits(this.cena) >>> 32));
        hash = 53 * hash + (this.vlastnictvi != null ? this.vlastnictvi.hashCode() : 0);
        return hash;
    }
}
